/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* TypeDef Declarations                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_TYPEDEF_CLASSES
#undef GET_TYPEDEF_CLASSES


namespace mlir {
class DialectAsmParser;
class DialectAsmPrinter;
} // namespace mlir
namespace mlir {
namespace test {
  class CompoundAType;
  class TestIntegerType;
  class SimpleAType;
  class StructType;
  class TestMemRefElementTypeType;
  class TestType;
  class TestTypeWithLayoutType;

  namespace detail {
    struct CompoundATypeStorage;
  } // end namespace detail
  class CompoundAType : public ::mlir::Type::TypeBase<CompoundAType, ::mlir::Type,
                                         detail::CompoundATypeStorage> {
  public:
    /// Inherit some necessary constructors from 'TypeBase'.
    using Base::Base;


    struct SomeCppStruct {};
  
    static CompoundAType get(::mlir::MLIRContext *context, int widthOfSomething, ::mlir::Type oneType, ::llvm::ArrayRef<int> arrayOfInts);
    static constexpr ::llvm::StringLiteral getMnemonic() {
      return ::llvm::StringLiteral("cmpnd_a");
    }

    static ::mlir::Type parse(::mlir::MLIRContext *context,
                             ::mlir::DialectAsmParser &parser);
    void print(::mlir::DialectAsmPrinter &printer) const;
    int getWidthOfSomething() const;
    ::mlir::Type getOneType() const;
    ::llvm::ArrayRef<int> getArrayOfInts() const;
  };

  namespace detail {
    struct TestIntegerTypeStorage;
  } // end namespace detail
  class TestIntegerType : public ::mlir::Type::TypeBase<TestIntegerType, ::mlir::Type,
                                         detail::TestIntegerTypeStorage> {
  public:
    /// Inherit some necessary constructors from 'TypeBase'.
    using Base::Base;


    /// Signedness semantics.
    enum SignednessSemantics {
      Signless, /// No signedness semantics
      Signed,   /// Signed integer
      Unsigned, /// Unsigned integer
    };

    /// Return true if this is a signless integer type.
    bool isSignless() const { return getSignedness() == Signless; }
    /// Return true if this is a signed integer type.
    bool isSigned() const { return getSignedness() == Signed; }
    /// Return true if this is an unsigned integer type.
    bool isUnsigned() const { return getSignedness() == Unsigned; }
  
    static TestIntegerType get(::mlir::MLIRContext *context, unsigned width, SignednessSemantics signedness = Signless);
    static TestIntegerType getChecked(llvm::function_ref<mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, unsigned width, SignednessSemantics signedness = Signless);

    using Base::getChecked;
    static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, unsigned width, ::mlir::test::TestIntegerType::SignednessSemantics signedness);
    static constexpr ::llvm::StringLiteral getMnemonic() {
      return ::llvm::StringLiteral("int");
    }

    static ::mlir::Type parse(::mlir::MLIRContext *context,
                             ::mlir::DialectAsmParser &parser);
    void print(::mlir::DialectAsmPrinter &printer) const;
    unsigned getWidth() const;
    ::mlir::test::TestIntegerType::SignednessSemantics getSignedness() const;
  };

  class SimpleAType : public ::mlir::Type::TypeBase<SimpleAType, ::mlir::Type, ::mlir::TypeStorage> {
  public:
    /// Inherit some necessary constructors from 'TypeBase'.
    using Base::Base;
    static constexpr ::llvm::StringLiteral getMnemonic() {
      return ::llvm::StringLiteral("smpla");
    }
  };

  namespace detail {
    struct StructTypeStorage;
  } // end namespace detail
  class StructType : public ::mlir::Type::TypeBase<StructType, ::mlir::Type,
                                         detail::StructTypeStorage> {
  public:
    /// Inherit some necessary constructors from 'TypeBase'.
    using Base::Base;

    static StructType get(::mlir::MLIRContext *context, ::llvm::ArrayRef<::mlir::test::FieldInfo> fields);
    static constexpr ::llvm::StringLiteral getMnemonic() {
      return ::llvm::StringLiteral("struct");
    }

    static ::mlir::Type parse(::mlir::MLIRContext *context,
                             ::mlir::DialectAsmParser &parser);
    void print(::mlir::DialectAsmPrinter &printer) const;
    ::llvm::ArrayRef<::mlir::test::FieldInfo> getFields() const;
  };

  class TestMemRefElementTypeType : public ::mlir::Type::TypeBase<TestMemRefElementTypeType, ::mlir::Type, ::mlir::TypeStorage, ::mlir::MemRefElementTypeInterface::Trait> {
  public:
    /// Inherit some necessary constructors from 'TypeBase'.
    using Base::Base;
    static constexpr ::llvm::StringLiteral getMnemonic() {
      return ::llvm::StringLiteral("memref_element");
    }
  };

  class TestType : public ::mlir::Type::TypeBase<TestType, ::mlir::Type, ::mlir::TypeStorage, ::mlir::test::TestTypeInterface::Trait> {
  public:
    /// Inherit some necessary constructors from 'TypeBase'.
    using Base::Base;
    static constexpr ::llvm::StringLiteral getMnemonic() {
      return ::llvm::StringLiteral("test_type");
    }
    void printTypeC(Location loc) const;
  };

  namespace detail {
    struct TestTypeWithLayoutTypeStorage;
  } // end namespace detail
  class TestTypeWithLayoutType : public ::mlir::Type::TypeBase<TestTypeWithLayoutType, ::mlir::Type,
                                         detail::TestTypeWithLayoutTypeStorage, ::mlir::DataLayoutTypeInterface::Trait> {
  public:
    /// Inherit some necessary constructors from 'TypeBase'.
    using Base::Base;


    LogicalResult verifyEntries(DataLayoutEntryListRef params,
                                Location loc) const;

  private:
    unsigned extractKind(DataLayoutEntryListRef params,
                         StringRef expectedKind) const;

  public:
  
    static TestTypeWithLayoutType get(::mlir::MLIRContext *context, unsigned key);
    static constexpr ::llvm::StringLiteral getMnemonic() {
      return ::llvm::StringLiteral("test_type_with_layout");
    }

    static ::mlir::Type parse(::mlir::MLIRContext *context,
                             ::mlir::DialectAsmParser &parser);
    void print(::mlir::DialectAsmPrinter &printer) const;
    unsigned getKey() const;
    unsigned getTypeSizeInBits(const ::mlir::DataLayout & dataLayout, ::mlir::DataLayoutEntryListRef params) const;
    unsigned getABIAlignment(const ::mlir::DataLayout & dataLayout, ::mlir::DataLayoutEntryListRef params) const;
    unsigned getPreferredAlignment(const ::mlir::DataLayout & dataLayout, ::mlir::DataLayoutEntryListRef params) const;
    bool areCompatible(::mlir::DataLayoutEntryListRef oldLayout, ::mlir::DataLayoutEntryListRef newLayout) const;
  };
} // namespace test
} // namespace mlir

#endif  // GET_TYPEDEF_CLASSES

